windows_intel64.h File Reference
`#include "msvc_ia32_common.h"`
`#include <intrin.h>`
Include dependency graph for windows_intel64.h:

Go to the source code of this file.

## Macros

#define | __TBB_WORDSIZE 8
#define | __TBB_ENDIANNESS __TBB_ENDIAN_LITTLE
#define | __TBB_USE_FETCHSTORE_AS_FULL_FENCED_STORE 1
#define | __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE 1
#define | __TBB_USE_GENERIC_RELAXED_LOAD_STORE 1
#define | __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE 1

## Functions

__int8 __TBB_EXPORTED_FUNC | __TBB_machine_cmpswp1 (volatile void *ptr, __int8 value, __int8 comparand)
__int8 __TBB_EXPORTED_FUNC | __TBB_machine_fetchadd1 (volatile void *ptr, __int8 addend)
__int8 __TBB_EXPORTED_FUNC | __TBB_machine_fetchstore1 (volatile void *ptr, __int8 value)
__int16 __TBB_EXPORTED_FUNC | __TBB_machine_cmpswp2 (volatile void *ptr, __int16 value, __int16 comparand)
__int16 __TBB_EXPORTED_FUNC | __TBB_machine_fetchadd2 (volatile void *ptr, __int16 addend)
__int16 __TBB_EXPORTED_FUNC | __TBB_machine_fetchstore2 (volatile void *ptr, __int16 value)
long | __TBB_machine_cmpswp4 (volatile void *ptr, __int32 value, __int32 comparand)
long | __TBB_machine_fetchadd4 (volatile void *ptr, __int32 addend)
long | __TBB_machine_fetchstore4 (volatile void *ptr, __int32 value)
__int64 | __TBB_machine_cmpswp8 (volatile void *ptr, __int64 value, __int64 comparand)
__int64 | __TBB_machine_fetchadd8 (volatile void *ptr, __int64 addend)
__int64 | __TBB_machine_fetchstore8 (volatile void *ptr, __int64 value)

## Macro Definition Documentation

## __TBB_ENDIANNESS

#define __TBB_ENDIANNESS __TBB_ENDIAN_LITTLE

Definition at line 24 of file windows_intel64.h.

## __TBB_USE_FETCHSTORE_AS_FULL_FENCED_STORE

#define __TBB_USE_FETCHSTORE_AS_FULL_FENCED_STORE 1

Definition at line 67 of file windows_intel64.h.

## __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE

#define __TBB_USE_GENERIC_HALF_FENCED_LOAD_STORE 1

Definition at line 68 of file windows_intel64.h.

## __TBB_USE_GENERIC_RELAXED_LOAD_STORE

#define __TBB_USE_GENERIC_RELAXED_LOAD_STORE 1

Definition at line 69 of file windows_intel64.h.

## __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE

#define __TBB_USE_GENERIC_SEQUENTIAL_CONSISTENCY_LOAD_STORE 1

Definition at line 70 of file windows_intel64.h.

## __TBB_WORDSIZE

#define __TBB_WORDSIZE 8

Definition at line 23 of file windows_intel64.h.

## Function Documentation

## __TBB_machine_cmpswp1()

__int8 __TBB_EXPORTED_FUNC __TBB_machine_cmpswp1 | ( | volatile void * | ptr,
|  | __int8 | value,
|  | __int8 | comparand
| ) |  |

Referenced by tbb::internal::__TBB_CompareAndSwapGeneric< 1, int8_t >(), and __TBB_TryLockByte().

Here is the caller graph for this function:

## __TBB_machine_cmpswp2()

__int16 __TBB_EXPORTED_FUNC __TBB_machine_cmpswp2 | ( | volatile void * | ptr,
|  | __int16 | value,
|  | __int16 | comparand
| ) |  |

Referenced by tbb::internal::__TBB_CompareAndSwapGeneric< 2, int16_t >().

Here is the caller graph for this function:

## __TBB_machine_cmpswp4()

long __TBB_machine_cmpswp4 | ( | volatile void * | ptr,
|  | __int32 | value,
|  | __int32 | comparand
| ) |  |

inline

Definition at line 45 of file windows_intel64.h.

{
return _InterlockedCompareExchange( (long*)ptr, value, comparand );
}
value
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t ITT_FORMAT d void ITT_FORMAT p void ITT_FORMAT p __itt_model_site __itt_model_site_instance ITT_FORMAT p __itt_model_task __itt_model_task_instance ITT_FORMAT p void ITT_FORMAT p void ITT_FORMAT p void size_t ITT_FORMAT d void ITT_FORMAT p const wchar_t ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s const char ITT_FORMAT s no args void ITT_FORMAT p size_t ITT_FORMAT d no args const wchar_t const wchar_t ITT_FORMAT s __itt_heap_function void size_t int ITT_FORMAT d __itt_heap_function void ITT_FORMAT p __itt_heap_function void void size_t int ITT_FORMAT d no args no args unsigned int ITT_FORMAT u const __itt_domain __itt_id ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain __itt_id ITT_FORMAT p const __itt_domain __itt_id __itt_timestamp __itt_timestamp ITT_FORMAT lu const __itt_domain __itt_id __itt_id __itt_string_handle ITT_FORMAT p const __itt_domain ITT_FORMAT p const __itt_domain __itt_string_handle unsigned long long value
Definition: ittnotify_static.h:192

References value.

## __TBB_machine_cmpswp8()

__int64 __TBB_machine_cmpswp8 | ( | volatile void * | ptr,
|  | __int64 | value,
|  | __int64 | comparand
| ) |  |

inline

Definition at line 55 of file windows_intel64.h.

{
return _InterlockedCompareExchange64( (__int64*)ptr, value, comparand );
}

References value.

## __TBB_machine_fetchadd1()

__int8 __TBB_EXPORTED_FUNC __TBB_machine_fetchadd1 | ( | volatile void * | ptr,
|  | __int8 | addend
| ) |  |

## __TBB_machine_fetchadd2()

__int16 __TBB_EXPORTED_FUNC __TBB_machine_fetchadd2 | ( | volatile void * | ptr,
|  | __int16 | addend
| ) |  |

## __TBB_machine_fetchadd4()

long __TBB_machine_fetchadd4 | ( | volatile void * | ptr,
|  | __int32 | addend
| ) |  |

inline

Definition at line 48 of file windows_intel64.h.

{
return _InterlockedExchangeAdd( (long*)ptr, addend );
}

## __TBB_machine_fetchadd8()

__int64 __TBB_machine_fetchadd8 | ( | volatile void * | ptr,
|  | __int64 | addend
| ) |  |

inline

Definition at line 58 of file windows_intel64.h.

{
return _InterlockedExchangeAdd64( (__int64*)ptr, addend );
}

## __TBB_machine_fetchstore1()

__int8 __TBB_EXPORTED_FUNC __TBB_machine_fetchstore1 | ( | volatile void * | ptr,
|  | __int8 | value
| ) |  |

## __TBB_machine_fetchstore2()

__int16 __TBB_EXPORTED_FUNC __TBB_machine_fetchstore2 | ( | volatile void * | ptr,
|  | __int16 | value
| ) |  |

## __TBB_machine_fetchstore4()

long __TBB_machine_fetchstore4 | ( | volatile void * | ptr,
|  | __int32 | value
| ) |  |

inline

Definition at line 51 of file windows_intel64.h.

{
return _InterlockedExchange( (long*)ptr, value );
}

References value.

## __TBB_machine_fetchstore8()

__int64 __TBB_machine_fetchstore8 | ( | volatile void * | ptr,
|  | __int64 | value
| ) |  |

inline

Definition at line 61 of file windows_intel64.h.

{
return _InterlockedExchange64( (__int64*)ptr, value );
}

References value.

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.